unit MyFunc;

interface

uses
   Math, SysUtils ;

const
   _LIMIT = 0.00000001;
   _LIMITN = 0.0000000001;

   function SInt(s:string):integer ;
   function SDbl(s:string):double ;
   function CoStr(V:Longint) : string ;
   function CoDStr(V1:double;V2:integer) : string ;
	function KTrim(s:string): string ;
	function CTrim(s:string): string ;

   procedure SwapI(var V1,V2:integer) ;
   procedure SwapF(var V1,V2:double) ;
   function  Roff(V:double) : double ;
   function  Dist(x1,y1,x2,y2:double):double ;
   function   Angle(dx,dy:double):double ;
   function  dAngle(dx,dy:double):double ;
   procedure  Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
   procedure dRev(var rx,ry:double;x,y,cx,cy,a:double) ;
   function   RevX(x,y,cx,cy,a:double):double ;
   function   RevY(x,y,cx,cy,a:double):double ;
   procedure  GetEllipsePt(var x,y:double;cx,cy,cr,he,ka,ang:double);
   procedure dGetEllipsePt(var x,y:double;cx,cy,cr,he,ka,ang:double);
   function   GetEllipseAngle(x,y,cx,cy,cr,he,ka:double) : double ;
   function  dGetEllipseAngle(x,y,cx,cy,cr,he,ka:double) : double ;
   function   GetDistPtLine(x1,y1,x2,y2,xp,yp:double):double ;
   function   Get3ptArc(x1,y1,x2,y2,x3,y3:double;var x,y,r,sa,ea:double;var d:Boolean) : Boolean ;
   function  dGet3ptArc(x1,y1,x2,y2,x3,y3:double;var x,y,r,sa,ea:double;var d:Boolean) : Boolean ;
   function  JwTextLen(s:string;w,d:double) : double ;

implementation

// ---------- - ---------- - ----------
//       ֐E葱
//       Ƃ̕ϊ֐E葱
// ---------- - ---------- - ----------

// 񁨐
function SInt(s:string):integer ;
var
   a,i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0;
   end
   else
      a := 0;
   Result := a;
end;

// 񁨎(double)
function SDbl(s:string):double ;
var
   a : double ;
   i : integer ;
begin
   if (s <> '') then begin
      Val(s,a,i);
      if (i <> 0) then
         a := 0.0;
   end
   else
      a := 0.0;
   Result := a;
end;

// {lR}t̐lƂĕɕϊ
function CoStr(V:Longint) : string ;
var
   a : double ;
begin
   a := V ;
   Result := Format('%.0n',[a]);
end ;

// lR}t̐lƂĕɕϊ
//  in : V1 : l
//       V2 : _ȉ
function CoDStr(V1:double;V2:integer) : string ;
var
   s : string ;
begin
   s := '%.' + IntToStr(V2) + 'n' ;
   Result := Format(s,[V1]);
end ;

// 󔒁iSp^pj菜
function KTrim(s:string): string ;
var
   i,i1:Integer ;
	r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(s) ;
	while(i <= i1) do begin
		if (Ord(s[i]) >= 128)and(Ord(s[i]) <= 159)
       or(Ord(s[i]) >= 224)and(Ord(s[i]) <= 253) then begin
      	// 
			t := s[i]+s[i+1] ;
			if (t <> '@') then r := r + t ;
			i := i + 2 ;
		end
      else begin
      	// ANK
			t := s[i] ;
			if (t <> ' ')and(Ord(s[i]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;

// Rg[R[h菜
function CTrim(s:string): string ;
var
   i,i1:Integer ;
	r,t : string ;
begin
	r := '' ;
	i := 1 ;
	i1 := Length(s) ;
	while(i <= i1) do begin
		if (Ord(s[i]) >= 128)and(Ord(s[i]) <= 159)
       or(Ord(s[i]) >= 224)and(Ord(s[i]) <= 253) then begin
      	// 
			t := s[i]+s[i+1] ;
			r := r + t ;
			i := i + 2 ;
		end
      else begin
      	// ANK
			t := s[i] ;
			if (Ord(s[i]) >= 32) then r := r + t ;
	      Inc(i);
      end;
   end;
	Result := r ;
end;


// ---------- - ---------- - ----------
//       vZϊ֐E葱
// ---------- - ---------- - ----------

// ̂Qľ
procedure SwapI(var V1,V2:integer) ;
var
	w : integer ;
begin
   w  := V1 ;
   V1 := V2 ;
   V2 := w ;
end;

// ̂Qľ
procedure SwapF(var V1,V2:double) ;
var
	w : double ;
begin
   w  := V1 ;
   V1 := V2 ;
   V2 := w ;
end;

// 덷ۂ
//    _ȉ11Ŏľܓď_ȉ10ɂ
function Roff(V:double) : double ;
var
	r : double ;
begin
	r := Int(Abs(V)/_LIMITN + 0.5)*_LIMITN ;
   if (V < 0.0) then r := -r ;
	Result := r ;
end;

// ijvZ
//@@x1,y1 : n_
//@@x2,y2 : I_
//@@out : ()
function Dist(x1,y1,x2,y2:double):double ;
begin
	Result := Sqrt((x2-x1)*(x2-x1) + (y2-y1)*(y2-y1)) ;
end;

// pxvZ[rad]
//@@dx : X
//@@dy : Y
//@@out: px (0`2*Pi)
function Angle(dx,dy:double):double ;
var
   r : double ;
begin
	Result := 0.0 ;
	if (Abs(dx) < _LIMITN)and(Abs(dy) < _LIMITN) then exit ;
	r := ArcTan2(dy,dx);
	if (r < 0.0) then r := r + 2.0 * Pi ;
   Result := r ;
end;

// pxvZ[]
//@@dx : X
//@@dy : Y
//@@out: px (0`360)
function dAngle(dx,dy:double):double ;
var
   r : double ;
begin
	r := Angle(dx,dy)*180.0/Pi ;
   Result := Roff(r) ;     // 덷ۂ߂ĕԂ
end;

// ][rad]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[rad]
procedure Rev(var rx,ry:double;x,y,cx,cy,a:double) ;
begin
   rx := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
   ry := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
end;

// ][]
//    rx,ry : ]̍W
//    x ,y  : W
//    cx,cy : ]SW
//    a     : ]px[]
procedure dRev(var rx,ry:double;x,y,cx,cy,a:double) ;
var
   an : double ;  // WAl
begin
   an := a/180.0*Pi ;
   Rev(rx,ry, x,y,cx,cy,an) ;
end;

// ]x [rad]
//    x,y   :W
//    cx,cy :]SW
//    a     :]px[rad]
//    out   :]xW
//    ʏ́ARevAdRev 䗘p
function RevX(x,y,cx,cy,a:double):double ;
var
   w : double ;
begin
   w := cx + (x-cx)*Cos(a) - (y-cy)*Sin(a) ;
   Result := w ;
end;

// ]y [rad]
//    x,y   :W
//    cx,cy :]SW
//    a     :]px[rad]
//    out   :]yW
//    ʏ́ARevAdRev 䗘p
function RevY(x,y,cx,cy,a:double):double ;
var
   w : double ;
begin
   w := cy + (x-cx)*Sin(a) + (y-cy)*Cos(a) ;
   Result := w ;
end;

// ȉ~̓_擾mangn
//    (ret)x,y : ȉ~̓_W
//    cx,cy : ȉ~S_
//    cr    : ȉ~a
//    he    : ȉ~Ε
//    ka    : Xpx[ang]
//    ang   : wpx[ang]
procedure GetEllipsePt(var x,y:double;cx,cy,cr,he,ka,ang:double);
var
   xx,yy : double ;
begin
   xx := cr   *Cos(ang);
   yy := cr*he*Sin(ang);
   Rev(x,y, xx,yy, 0.0,0.0, ka);
   x := x + cx ;
   y := y + cy ;
end;

// ȉ~̓_擾mn
//    (ret)x,y : ȉ~̓_W
//    cx,cy : ȉ~S_
//    cr    : ȉ~a
//    he    : ȉ~Ε
//    ka    : Xpx[]
//    ang   : wpx[]
procedure dGetEllipsePt(var x,y:double;cx,cy,cr,he,ka,ang:double);
var
   kn,an : double ;
begin
   kn := ka /180.0*Pi ;
   an := ang/180.0*Pi ;
   GetEllipsePt(x,y, cx,cy,cr,he,kn,an);
end;

// ȉ~̓_ւ̊px擾mangn
//    x,y   : ȉ~̓_W
//    cx,cy : ȉ~S_
//    cr    : ȉ~a
//    he    : ȉ~Ε
//    ka    : Xpx[ang]
//    (ret) : px[ang]
function GetEllipseAngle(x,y,cx,cy,cr,he,ka:double) : double ;
var
   xx,yy : double ;
begin
   if (he <= 0.0) then he := 1.0;   // ꉞErrorCheck
   Rev(xx,yy, x,y, cx,cy, -ka);
   xx :=  xx - cx ;
   yy := (yy - cy)/he ;
   Result := Angle(xx,yy);
end;

// ȉ~̓_ւ̊px擾mn
//    x,y   : ȉ~̓_W
//    cx,cy : ȉ~S_
//    cr    : ȉ~a
//    he    : ȉ~Ε
//    ka    : Xpx[]
//    (ret) : px[]
function dGetEllipseAngle(x,y,cx,cy,cr,he,ka:double) : double ;
var
   kn,r : double ;
begin
   kn := ka/180.0*Pi ;
   r  := GetEllipseAngle(x,y,cx,cy,cr,he,kn) * 180.0/Pi ;
   Result := Roff(r) ;
end;

// Ɠ_̋Z
//    x1,y1 : ̊Jn_
//    x2,y2 : ̏I_
//    xp,yp : _@̔zu_
//    (ret) : Ɠ_Ƃ̋
function GetDistPtLine(x1,y1,x2,y2,xp,yp:double):double ;
var
	w1 : double ;
begin
	w1 := Angle((x2-x1),(y2-y1));
	Result := Abs(RevY(xp,yp,x1,y1,-w1) - y1);
end;

// R_ʉ߂~ʂZmradn
//		x1,y1 : Jn_
//		x2,y2 : ʉߓ_
//		x3,y3 : I_
//    x,y,r,sa,ea : ʂ̉~ʁisa,ea[rad]j
//    d     : True:sa=x1,y1  False:sa=x3,y3
//    (ret) : True : OK@False : Error
//    G[ivZoȂꍇj́Ax,y,r,sa,ea ̊eĺu0vƂȂ܂
function Get3ptArc(x1,y1,x2,y2,x3,y3:double;var x,y,r,sa,ea:double;var d:Boolean) : Boolean ;
var
	w,w1,w2,w3 : double ;
   dd : Boolean ;
begin
   x := 0.0;
   y := 0.0;
   r := 0.0;
   sa:= 0.0;
   ea:= 0.0;
   d := False;
	Result := False ;
	// ォǂ`FbN
	w1 := GetDistPtLine(x1,y1,x2,y2,x3,y3);
   if (w1 < _LIMITN) then exit ;

   w1 := (x3-x2)*(y1-y2)-(y3-y2)*(x1-x2) ;
   if (Abs(w1) < _LIMITN) then exit ;
   w2 := -0.5*(x3-x2)*(x2*x2+y2*y2-x1*x1-y1*y1);
	w3 := -0.5*(x1-x2)*(x2*x2+y2*y2-x3*x3-y3*y3);
   y := (w2-w3)/w1 ;
   w1 := (x1-x2)*(y3-y2)-(y1-y2)*(x3-x2) ;
   if (Abs(w1) < _LIMITN) then exit ;
   w2 := -0.5*(y3-y2)*(x2*x2+y2*y2-x1*x1-y1*y1);
	w3 := -0.5*(y1-y2)*(x2*x2+y2*y2-x3*x3-y3*y3);
   x := (w2-w3)/w1 ;
	r := sqrt((x1-x)*(x1-x)+(y1-y)*(y1-y));
	if (r < _LIMITN) then exit ;
	w1 := Angle((x1-x),(y1-y));
	w2 := Angle((x2-x),(y2-y));
	w3 := Angle((x3-x),(y3-y));
   dd := True ;
   if (w1 > w3) then begin
      w  := w1 ;
      w1 := w3 ;
      w3 := w  ;
      dd := False ;
   end;
   if (w1 <= w2)and(w2 <= w3) then begin
      sa := w1 ;
      ea := w3 ;
      if (dd) then
         d := True
      else
         d := False ;
   end
   else begin
      sa := w3 ;
      ea := w1 ;
      if (dd) then
         d := False
      else
         d := True ;
   end;
	Result := True ;
end;

// R_ʉ߂~ʂZmn
//		x1,y1 : Jn_
//		x2,y2 : ʉߓ_
//		x3,y3 : I_
//    x,y,r,sa,ea : ʂ̉~ʁisa,ea[]j
//    d     : True:sa=x1,y1  False:sa=x3,y3
//    (ret) : True : OK@False : Error
//    G[ivZoȂꍇj́Ax,y,r,sa,ea ̊eĺu0vƂȂ܂
function dGet3ptArc(x1,y1,x2,y2,x3,y3:double;var x,y,r,sa,ea:double;var d:Boolean) : Boolean ;
var
   re : Boolean ;
   sa1,ea1 : double ;
begin
   re := Get3ptArc(x1,y1,x2,y2,x3,y3, x,y,r,sa1,ea1, d);
   sa := Roff(sa1) ;     // 덷ۂ߂ĕԂ
   ea := Roff(ea1) ;
   Result := re ;
end;

// Jw_cad Z
//    s : e
//    w : @[}mm]
//    d : Ԋu[}mm]
// (ret): [}mm]
// v|[VitHgɂ͖Ή
function  JwTextLen(s:string;w,d:double) : double ;
var
   i,i1:Integer ;
   r : double ;
begin
   r := 0.0;
	i := 1 ;
	i1 := Length(s) ;
	while(i <= i1) do begin
		if (Ord(s[i]) >= 128)and(Ord(s[i]) <= 159)
       or(Ord(s[i]) >= 224)and(Ord(s[i]) <= 253) then begin
      	// 
         r := r + w ;
			i := i + 2 ;
         if (i <= i1) then r := r + d ;
		end
      else begin
      	// ANK
			if (Ord(s[i]) >= 32) then r := r + w*0.5 ;
	      Inc(i);
         if (i <= i1) then r := r + d*0.5 ;
      end;
   end;
	Result := r ;
end;

end.
